import usb
from subprocess import call
import os
from time import sleep

####################################
VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH = 1
VENDOR_RQ_GET_LIGHT  = 2
VENDOR_RQ_PLAYER = 3
VENDOR_RQ_SET_PLAY = 4

####################################
class Board:
    def __init__(self):
        #print "Looking for MCU board..."
        dev = self.find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def find_board(self):
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def set_led(self,pin,val):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None, value=val*256+pin,timeout=100000)

    def get_switch(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH, 1,timeout=100000)
        return buf[0]

    def get_sound(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT, 2,timeout = 100000)
        return buf[1]*256+buf[0]

    def set_play(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        self.handle.controlMsg(reqType, VENDOR_RQ_SET_PLAY, 4, value=1,timeout=100000)


    
